<?php
/**
 * Plugin for Yana PHP-Framework
 *
 * Software:        Yana PHP-Framework 3.0.0
 * Author:          Dipl. Inf. Thomas Meyer
 * Homepage:        http://www.yanaframework.net
 * Copyright:       (c) 2009  Thomas Meyer
 * License:         GNU GPL  http://www.gnu.org/licenses/
 *
 * This program: can be redistributed and/or modified under the
 * terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see http://www.gnu.org/licenses/.
 *
 * You may use this software for free. In case you like it, or want to
 * use it for a commercial purpose, please consider making a donation.
 * http://yanaframework.net/donate.php
 *
 * This notice MAY NOT be removed.
 *
 *
 * @author     Thomas Meyer
 * @license    http://www.gnu.org/licenses/gpl.txt
 * @package    yana
 * @subpackage plugins
 */

/**
 * guestbook setup
 *
 * This implements basic setup functions for the guestbook plugin.
 *
 * @access     public
 * @package    yana
 * @subpackage plugins
 */
class plugin_guestbook_admin extends Plugin
{
    /**
     * Default event handler
     *
     * returns bool(true) on success and bool(false) on error
     *
     * @access  public
     * @param   string  $event  name of the called event in lower-case
     * @param   array   $ARGS   array of arguments passed to the function
     * @return  bool
     * @ignore
     */
    function _default($event, $ARGS)
    {
        global $YANA;
        /* do nothing */
        return true;
    }

    /**
     * event handler
     *
     * this function does not expect any arguments
     *
     * @access  public
     * @param   array  $ARGS array of params passed to the function
     * @return  bool
     * @ignore
     */
    function get_admin($ARGS)
    {
        /* this function expects no arguments */

        global $YANA;
        $YANA->language->read("admin");
        $YANA->setVar("DESCRIPTION", $YANA->getVar("LANGUAGE.DESCR_ADMIN"));
        $YANA->setVar("WRITEABLE",    $YANA->registry->files['config']->isWriteable());
        return true;
    }

    /**
     * event handler
     *
     * this function does not expect any arguments
     *
     * @access  public
     * @param   array  $ARGS array of params passed to the function
     * @return  bool
     * @ignore
     */
    function get_mod($ARGS)
    {
        /* this function expects no arguments */

        global $YANA;
        $YANA->language->read("admin");
        $YANA->setVar("DESCRIPTION", $YANA->getVar("LANGUAGE.DESCR_MOD"));
        $YANA->setVar("WRITEABLE",    $YANA->registry->files['config']->isWriteable());
        return true;
    }

}
// Copyright  2009  Thomas Meyer  http://www.yanaframework.net
?>