/**
 * AJAX - Yana Bridge for plugin "[%$ID%]"
 *
 * This file was generated automatically by the Yana-SDK code generator.
 *
[%if $VERSION%] * @version     [%$VERSION%]
[%/if%] * @package     plugins
 */

/**
 * constructor "[%$CLASS%]"
 *
 * Usage:
 * <code>
 * <div id="foo"></div>
 *
 * [...]
 *
 * var o = new [%$CLASS%]("foo");
 * o.nameOfFunction("arg1=value1&arg2=value2");
 * </code>
 *
 * This will send a request using the given argument list
 * and output the results to the tag with the id "foo".
 *
 * For more details see the manual and API documentation.
 *
 * @access      public
 * @package     plugins
[%if $PACKAGE%] * @subpackage  [%$PACKAGE%]
[%/if%]
 * @param       string  id
 */
function [%$CLASS%] ($id)
{
    if ($id && typeof $id != 'string') {
        alert('Wrong argument type for argument 1 in constructor [%$CLASS%](). String expected, found "'+(typeof $id)+'" instead.');
        return;
    } else if (!$id) {
        $id = "yana_stdout";
    }

    if (typeof php_self != 'undefined') {
        var src = php_self;
    } else {
        var src = "";
    }

    if (AjaxRequest) {
        this.http = new AjaxRequest(src);
        if (!document.getElementById($id)) {
            alert('Invalid id in constructor [%$CLASS%](). The container "'+$id+'" was not found.');
        } else {
            this.http.setTarget($id);
        }
    } else {
        alert('Unable to create new instance of "[%$CLASS%]". A required class "AjaxRequest" was not found.');
    }
}

/**
 * call YANA-function by name
 *
 * @param   string  $func     name of function to execute
 * @param   string  $args     (optional) params passed to the function call
 * @param   string  $handler  (optional) reference to a function that serves as a custom event handler
 * @name    [%$CLASS%]::callFunctionByName()
 */
[%$CLASS%].prototype.callFunctionByName = function($func, $args, $handler)
{
    if ($func && typeof $func  != 'string') {
        alert('Wrong argument type for argument 1 in method [%$CLASS%].callFunctionByName(). String expected, found "'+(typeof $func)+'" instead.');
        return;
    } else if ($args && typeof $args  != 'string') {
        alert('Wrong argument type for argument 2 in method [%$CLASS%].callFunctionByName(). String expected, found "'+(typeof $args)+'" instead.');
        return;
    } else if ($handler && typeof $handler != 'Function' && typeof $handler != 'function') {
        alert('Wrong argument type for argument 3 in method [%$CLASS%].callFunctionByName(). Function expected, found "'+(typeof $handler)+'" instead.');
        return;
    } else {
        if ($handler) {
            this.http.setHandler($handler);
        } else {
            this.http.setHandler(function (httpResponse, htmlNode)
            {
                // put event handling code here !
                // See this example:
                htmlNode.innerHTML = httpResponse.responseText;
                // this will re-initialize the page (when needed)
                if (document.body.onload) {
                    document.body.onload();
                }                
            });
        }
        this.http.send('action=' + escape($func) + '&' + $args);
    }
}

/* BEGIN custom events */

[%foreach key="NAME" item="CURRENT" from=$INTERFACE%]

/**
 * [%$NAME%]
 *
 * Type:        [%$CURRENT.TYPE%]
 * Permission:  [%$CURRENT.PERMISSION%]
 * Templates:   [%if $CURRENT.TEMPLATE%][%$CURRENT.TEMPLATE%] [%/if%][%$CURRENT.INSERT%]
 *
 * @access  public
 * @param   string  $args     (optional) params passed to the function call
 * @param   string  $handler  (optional) reference to a function that serves as a custom event handler
 */
[%$CLASS%].prototype.[%$NAME|replace:'_':' '|capitalize:true|replace:' ':''%] = function ($args, $handler)
{
    // you may put your own code here
    this.callFunctionByName("[%$NAME%]", $args, $handler);
}

[%/foreach%]

/* END custom events */

/* BEGIN database events */

[%foreach key="NAME" item="CURRENT" from=$AUTO_INTERFACE%]
[%assign var="NAME" value=$NAME|lower%]

/**
 * [%$NAME%]
 *
 * Type:        [%$CURRENT.TYPE%]
 * Permission:  [%$CURRENT.PERMISSION%]
 * Templates:   [%if $CURRENT.TEMPLATE%][%$CURRENT.TEMPLATE%] [%/if%][%$CURRENT.INSERT%]
 *
 * @access  public
 * @param   string  $args     (optional) params passed to the function call
 * @param   string  $handler  (optional) reference to a function that serves as a custom event handler
 */
[%$CLASS%].prototype.[%$NAME|replace:'_':' '|capitalize:true|replace:' ':''%] = function ($args, $handler)
{
    // you may put your own code here
    this.callFunctionByName("[%$NAME%]", $args, $handler);
}

[%/foreach%]

/* END database events */
/**
 * Yana Framework 3.0.0
 * Copyright  2009  Thomas Meyer  http://www.yanaframework.net
 * Copyright Hinweise drfen NICHT entfernen werden!
 * Copyright notices may NOT be removed!
 */